bunch of updates and fixes
[distro-setup] / system-status
index 78d0fdaec1628894869d7459a6712994352053b8..c6f3fe7f5144d3c3661196289cc8cfbb062059ed 100755 (executable)
@@ -6,41 +6,64 @@
 
 if [ -z "$BASH_VERSION" ]; then echo "error: shell is not bash" >&2; exit 1; fi
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
-
+source /a/bin/errhandle/err
 status_file=/dev/shm/iank-status
 
 shopt -s nullglob
 shopt -s dotglob
 
+lo() { /usr/local/bin/log-once "$@"; }
+
 write-status() {
   chars=()
 
   glob=(/nocow/btrfs-stale/*)
-  if [[ -e $glob ]] ; then
+  if [[ -e ${glob[0]} ]]; then
     chars+=("STALE!")
   fi
   glob=(/m/md/bounces/new/*)
-  if [[ -e $glob ]]; then
+  if [[ -e ${glob[0]} ]]; then
     chars+=("BOUNCE!")
+    bouncemsg="message in /m/md/bounces/new"
   fi
+  lo -1 bounce $bouncemsg
   glob=(/m/md/alerts/new/* /m/md/alerts/cur/*)
-  if [[ -e $glob ]]; then
+  if [[ -e ${glob[0]} ]]; then
     chars+=("ALERT!")
   fi
   if [[ -e /nocow/user/mailtest-failure ]]; then
     chars+=("MAILPING!")
   fi
+
+  ## Clean the paniclog, but only up to 4 times per day, or else we
+  ## should investigate.
+  loglog=/tmp/panicloglog-$(date --rfc-3339=date)
+  if [[ -s $loglog ]]; then
+    spamcount=$(stat -c%s $loglog)
+  else
+    spamcount=0
+  fi
+  if (( spamcount <= 4 )); then
+    if grep -q 'spam acl condition' /var/log/exim4/paniclog; then
+      printf . >>$loglog
+    fi
+    /a/bin/distro-setup/epanic-clean
+  fi
+
   if [[ -s /var/log/exim4/paniclog ]]; then
     chars+=("PANIC!")
+    tail -n 20 /var/log/exim4/paniclog | lo -1 paniclog
+  else
+    lo -1 paniclog
   fi
 
   source /a/bin/bash_unpublished/source-state
-  if [[ $MAIL_HOST == $HOSTNAME ]]; then
+  if [[ $MAIL_HOST == "$HOSTNAME" ]]; then
     if [[ $(systemctl is-active btrbk.timer) != active ]]; then
-      chars+=("BTRBK-TIMER!")
+      chars+=("BTRBK.TIMER!")
+      bbkmsg="btrbk.timer not enabled"
     fi
+    lo -60 btrbk.timer $bbkmsg
 
     ## check if last snapshot was within an hour
     vol=o
@@ -56,18 +79,20 @@ write-status() {
     done
     if (( maxtime < now - 60*60 )); then
       chars+=("OLD-SNAPSHOT!")
+      snapshotmsg="/o snapshot older than 1 hour"
     fi
+    lo -1 old-snapshot $snapshotmsg
   fi
 
   cat /a/bin/bash_unpublished/source-state >$status_file
 
-  if [[ $chars ]]; then
+  if [[ ${chars[*]} ]]; then
     echo "ps_char=\"${chars[*]} \$ps_char\"" >>$status_file
   fi
 
 }
 write-status
-if [[ $@ ]]; then
+if [[ $1 ]]; then
   cat $status_file
   exit 0
 fi